#ifndef _ROUTER_H
#define _ROUTER_H


#include "leds.h"
#include "GenericTypeDefs.h"
#include "Compiler.h"
#include "TCPIP Stack\MAC.h"
#include "TCPIP Stack\Helpers.h"
#include "TCPIP Stack\TCPIP.h"

#include "types.h"
#include "rules.h"

// BLOCK_SIZE must be greater than 28 bytes
// 3*256 = 768
//#define BLOCK_SIZE 768
#define BLOCK_SIZE 1520
extern BYTE buffer[BLOCK_SIZE];

extern fw_syslog *syslog_server;
extern fw_interface *intf;
extern fw_route *route;
extern CSX_CONTEXT context[3];

extern BYTE number_of_routes;


#define IS_BCAST_1(X) ((X) == 0xFFFFFFFFul)      
#define IS_BCAST_0(X) ((X) == 0x0ul)
#define IS_LOOPBACK(X)    (((X)&0xff000000ul) == 0x7F000000ul) 
#define IS_LTD_BCAST_1(IP,NET,MASK) ((IP) == ( ((NET)&(MASK))|(~(MASK)) ) )
#define IS_LTD_BCAST_0(IP,NET,MASK) ((IP) == ((NET)&(MASK)) )
#define IS_MCAST(X) (((X) & 0xf0000000ul) == 0xE0000000ul)


// #define ARP_CYCLE	(1ul*TICK_SECOND)
// #define ARP_LIMIT  4u
#define ARP_CYCLE	(TICK_SECOND/2ul)
#define ARP_LIMIT  3u

/* A shorthand way to reference the MAC address given the
   interface or CSX number */
   
#define INTF_MAC_ADDR(X)  ((MAC_ADDR *)(intf[X].mac))
#define MAC_CMP(a,b) (memcmp((void*)a,(void*)b,sizeof(MAC_ADDR)))




// number of entries for each interface (each CSX)
#define ROUTE_CACHE_LENGTH 6u

typedef struct _ROUTE_INFO {
    BYTE      CSX_dst;       
    NODE_INFO mac_src;
    NODE_INFO mac_dst;
  } ROUTE_INFO;  
  
// a single entry has storage for each CSX
struct ROUTE_CACHE_COLUMN {
  ROUTE_INFO entry[ROUTE_CACHE_LENGTH];
};

// this is the arp table
struct ROUTE_CACHE {
   BYTE pointer[NOI];
   struct ROUTE_CACHE_COLUMN csx[NOI];
};


void route_cache_init(void);
void route_cache_add(BYTE CSX);
BOOL route_cache_exec(BYTE CSX);

BOOL validate_address(BYTE CSX, IP_HEADER *header);
void intf_hex_to_ip(IP_ADDR *ip);

void route_packet(BYTE CSX_dst,
                 BYTE CSX_src,
                 NODE_INFO *dest,
                 NODE_INFO *source,
                 IP_HEADER *header,
                 WORD len); // length of the data in the IP packet
  
void initilize_rule_data(void);

BOOL set_route(BYTE CSX, NODE_INFO *dst, NODE_INFO *src);

  
#endif





