#ifndef __TYPES_H
#define __TYPES_H



/* 
 * Syslog server
 *
 * 
 *   |--------IP---------|ino|
 *    0xc0,0xa8,0x03,0x00,0x01
 */

      
typedef struct
  {
    DWORD_VAL ip;
    unsigned char ino;
  } fw_syslog;


/* 
 * Route
 *
 * 
 *   |--------NET--------|---------MASK------|ino|-------IP-----------|
 *    0xc0,0xa8,0x03,0x00,0xff,0xff,0xff,0x00,0x01,0xc0,0xa8,0x03,0x01,
 */

      
typedef struct
  {
    DWORD_VAL net;
    DWORD_VAL mask;      
    unsigned char ino;
    DWORD_VAL ip;
  } fw_route;


/*
 * Interface
 *
 *   |---------IP--------|---------MASK------|------------MAC--------------|
 *    0xc0,0xa8,0x02,0x0a,0xff,0xff,0xff,0x00,0x00,0x00,0x1d,0x08,0x42,0xac,
 */

typedef struct
  {
    DWORD_VAL ip;
    DWORD_VAL mask;
    unsigned char mac[6];
  } fw_interface;

/*
 * Rule
 *
 *    |PROT|-------SIP---------|-------SMASK-------|--SPORT--|-------DIP---------|-------DMASK-------|--DPORT--|ACT|
 *     0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x01,
 */

typedef struct
  {
    unsigned char proto;
    unsigned char sip[4];
    unsigned char smask[4];
    unsigned char sport[2];
    unsigned char dip[4];
    unsigned char dport[2];
    unsigned char dmask[4];
    unsigned char action;
  } fw_rule;




// ========================
// Pulled from StackTsk.h
// ========================

#define IP_ADDR		DWORD_VAL


typedef struct {
    BYTE v[6];
  } MAC_ADDR;

typedef struct __attribute__((__packed__)) _NODE_INFO
{
    IP_ADDR     IPAddr;
    MAC_ADDR    MACAddr;
} NODE_INFO;

#endif
